<?php
// osCommerce Product Manager for Windows (oscpmwin).
// Copyright 2003,2004 by Mario A. Valdez-Ramirez.

// You can contact Mario A. Valdez-Ramirez
// by email at mario@mariovaldez.org or paper mail at
// Olmos 809, San Nicolas, NL. 66495, Mexico.

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or (at
// your option) any later version.

// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
// General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA


// ==================================
// Start of configuration options...
// ==================================

$opm_jpeg_truecolors = true;
$opm_images_directory = "images/";
$opm_script_version = "0.1.0";

// ==================================
// End of configuration options...
// ==================================


$opm_realpath = str_replace (basename (__FILE__), "", __FILE__) . $opm_images_directory;
$opm_password = trim ($_POST["Pw"]);
$opm_operation = trim ($_POST["Op"]);
$opm_filename = str_replace ("\\", "", str_replace ("/", "", trim ($_POST["Fn"])));
$opm_smartrename = abs (trim ($_POST["SR"]));
$opm_reqversion = trim ($_POST["Vn"]);

if ($opm_smartrename > 0) {
  $opm_smartrename = 1;
}
else {
  $opm_smartrename = 0;
}


if (($opm_script_version != $opm_reqversion) && ($opm_operation)) {
  echo "ERROR WRONG SCRIPT VERSION";
  return;
}

if ($opm_operation == 'check') {
  if ($opm_filename) {
    if (file_exists ($opm_realpath . $opm_filename)) {
      echo "OK FILE EXISTS";
      return;
    }
    else {
      echo "ERROR FILE NOT FOUND";
      return;
    }
  }
}
if ($opm_operation == 'list') {
  echo "OK LIST START\n";
	$opm_dirhandle = opendir ($opm_realpath);
  while (($file = readdir ($opm_dirhandle)) != false)
    $opm_sorteddir[count ($opm_sorteddir)] = $file;
	closedir ($opm_dirhandle);
  natcasesort ($opm_sorteddir);
	foreach ($opm_sorteddir as $file) {
    if (($file != ".") && ($file != "..")) {
      if (!is_dir ($opm_realpath . $file)) {
        echo $file . "\n";
      }
    }
  }
  echo "OK LIST END\n";
  return;
}
if ($opm_operation == 'delete') {
  if ($opm_filename) {
    if (file_exists ($opm_realpath . $opm_filename)) {
      if (@unlink ($opm_realpath . $opm_filename)) {
        if (!file_exists ($opm_realpath . $opm_filename)) {
          echo "OK DELETE";
          return;
        }
        else {
          echo "ERROR DELETE FILE REMAINS";
          return;
        }
      }
      else {
        echo "ERROR DELETE UNKNOWN";
        return;
      }
    }
    else {
      echo "OK DELETE FILE NOT FOUND";
      return;
    }
  }
}
if ($opm_operation == 'upload') {
  if ($_FILES["Fl"]["name"] && $_FILES["Fl"]["size"]) {
    if (is_uploaded_file ($_FILES["Fl"]["tmp_name"])) {
      if ($opm_filename) {
        $newfn = $opm_filename;
      }
      else {
        $newfn = trim ($_FILES["Fl"]["name"]);
      }
      $newfn = str_replace (" ", "_", $newfn);
      $newfn = str_replace ("/", "", $newfn);
      $newfn = str_replace ("\\", "", $newfn);
      $newfn = ereg_replace("[^[:alnum:]\._]", "", $newfn);
      $newfn = strtolower ($newfn);
      if ($opm_smartrename == 1) {
        $newfn = opm_FNSmart_Rename ($newfn, 100);
      }
      if (!file_exists ($opm_realpath . $newfn)) {
        if (move_uploaded_file ($_FILES["Fl"]["tmp_name"], $opm_realpath . $newfn)) {
          if (file_exists ($opm_realpath . $newfn)) {
            echo "OK UPLOAD [" . $newfn . "]";
            return;
          }
          else {
            echo "ERROR UPLOAD FILE NOT FOUND";
            return;
          }
        }
      }
      else {
        echo "ERROR UPLOAD EXIST [" . $newfn . "]";
        return;
      }
    }
    else {
      echo "ERROR UPLOAD";
      return;
    }
  }
}


echo "<p>OSCommerce Product Manager, server-side script " . $opm_script_version . ".</p>";
return;



function opm_FNSmart_Rename ($wantedname, $tries) {
global $opm_realpath;
  $newname = $wantedname;
  $newext = '.' . array_pop (explode ('.', $wantedname));
  for ($trycounter = 1; $trycounter <= $tries; $trycounter++) {
    if (!file_exists ($opm_realpath . $newname)) {
      return ($newname);
    }
    else {
      $newname = basename ($wantedname, $newext) . "_" . $trycounter . $newext;
    }
  }
  return ($wantedname);
}









?>